using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Diagnostics;
using System.Threading;
using System.Text.RegularExpressions;

namespace ProcessSample
{
	/// <summary>
	/// Form1 ̊Tv̐łB
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button buttonFileDialog2;
		private System.Windows.Forms.Button buttonFileDialog1;
		private System.Windows.Forms.Label labelOption;
		private System.Windows.Forms.TextBox textBoxProgram;
		private System.Windows.Forms.Label labelProgram;
		private System.Windows.Forms.Button buttonStart;
		private System.Windows.Forms.Button buttonStop;
		private System.Windows.Forms.TextBox textBoxArgument;
		private System.ComponentModel.Container components = null;


		Process extProcess = null;
		Thread extThread = null;
		const string DefaultProgram = @"C:\Program Files\Internet Explorer\IEXPLORE.EXE";
		const string DefaultArgument = @"http://mobiquitous.com/";

		private const char Separator = '\t';
		private string lastDirectory = @"C:\Program Files\Internet Explorer\";

		public Form1()
		{
			InitializeComponent();

			textBoxProgram.Text = DefaultProgram;
			textBoxArgument.Text = DefaultArgument;
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			ControlProcess(false);
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		//OvZXXbh̊JnI
		private void ControlProcess(bool start)
		{
			if(!start && extThread!=null)
			{
				extThread.Abort();
				extThread = null;
			}
			else if(start && extThread ==null)
			{
				extThread = new Thread(new ThreadStart(ProcessWorker));
				extThread.Start();
			}
		}

		//OvZXN邽߂̃Xbh
		private void ProcessWorker()
		{
			string program = textBoxProgram.Text;
			string argument = textBoxArgument.Text;

			//OvZX̋N
			try
			{
				extProcess = new Process();
				extProcess.StartInfo.FileName = program;//Nt@C
				extProcess.StartInfo.Arguments = argument;
				extProcess.Start();
        
				//XbhI܂őҋ@
				while(true)
				{
					Thread.Sleep(100);
				}
			}
			catch(ThreadAbortException ex)
			{
			}
			catch(Exception ex)
			{
			}
			finally
			{
				if(extProcess!=null)
					extProcess.Kill();	//OvZX̏Iiɂ̃XbhIj
				extThread.Abort();
				extThread = null;
			}
		}

		//t@C_CAOJD(st@Cpj
		private void buttonFileDialog1_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog openDialog = new OpenFileDialog();
			openDialog.InitialDirectory = Application.StartupPath;
			openDialog.Filter = "exe files (*.exe)|*.exe|all files (*.*)|*.*" ;
			openDialog.FilterIndex = 1 ;
			openDialog.RestoreDirectory = true;
			openDialog.Multiselect = false;
			if(lastDirectory!="")
			{
				openDialog.InitialDirectory = lastDirectory;
			}

			if(openDialog.ShowDialog() == DialogResult.OK)
			{
				this.textBoxProgram.Text = openDialog.FileName;

				Match m = Regex.Match(openDialog.FileName, @"(.*)\\(.*)$");
				if(m.Success)
				{
					lastDirectory = m.Groups[0].Value;
				}
			}
		}

		//t@C_CAOJipj
		private void buttonFileDialog2_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog openDialog = new OpenFileDialog();
			openDialog.InitialDirectory = Application.StartupPath;
			openDialog.Filter = "all files (*.*)|*.*" ;
			openDialog.FilterIndex = 1 ;
			openDialog.RestoreDirectory = true ;
			openDialog.Multiselect = false;

			if(lastDirectory!="")
			{
				openDialog.InitialDirectory = lastDirectory;
			}

			if(openDialog.ShowDialog() == DialogResult.OK)
			{
				this.textBoxArgument.Text = openDialog.FileName;
				Match m = Regex.Match(openDialog.FileName, @"(.*)\\(.*)$");
				if(m.Success)
				{
					lastDirectory = m.Groups[0].Value;
				}
			}
		}

		
		private void buttonStart_Click(object sender, System.EventArgs e)
		{
			ControlProcess(true);
			buttonStart.Enabled = false;
			buttonStop.Enabled = true;
		}

		private void buttonStop_Click(object sender, System.EventArgs e)
		{
			ControlProcess(false);
			buttonStart.Enabled = true;
			buttonStop.Enabled = false;
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonFileDialog2 = new System.Windows.Forms.Button();
			this.buttonFileDialog1 = new System.Windows.Forms.Button();
			this.textBoxArgument = new System.Windows.Forms.TextBox();
			this.labelOption = new System.Windows.Forms.Label();
			this.textBoxProgram = new System.Windows.Forms.TextBox();
			this.labelProgram = new System.Windows.Forms.Label();
			this.buttonStart = new System.Windows.Forms.Button();
			this.buttonStop = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// buttonFileDialog2
			// 
			this.buttonFileDialog2.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonFileDialog2.Location = new System.Drawing.Point(248, 56);
			this.buttonFileDialog2.Name = "buttonFileDialog2";
			this.buttonFileDialog2.Size = new System.Drawing.Size(56, 23);
			this.buttonFileDialog2.TabIndex = 18;
			this.buttonFileDialog2.Text = "Q";
			this.buttonFileDialog2.Click += new System.EventHandler(this.buttonFileDialog2_Click);
			// 
			// buttonFileDialog1
			// 
			this.buttonFileDialog1.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonFileDialog1.Location = new System.Drawing.Point(248, 16);
			this.buttonFileDialog1.Name = "buttonFileDialog1";
			this.buttonFileDialog1.Size = new System.Drawing.Size(56, 23);
			this.buttonFileDialog1.TabIndex = 17;
			this.buttonFileDialog1.Text = "Q";
			this.buttonFileDialog1.Click += new System.EventHandler(this.buttonFileDialog1_Click);
			// 
			// textBoxArgument
			// 
			this.textBoxArgument.Location = new System.Drawing.Point(62, 56);
			this.textBoxArgument.Name = "textBoxArgument";
			this.textBoxArgument.Size = new System.Drawing.Size(160, 19);
			this.textBoxArgument.TabIndex = 16;
			this.textBoxArgument.Text = "";
			// 
			// labelOption
			// 
			this.labelOption.Location = new System.Drawing.Point(16, 56);
			this.labelOption.Name = "labelOption";
			this.labelOption.Size = new System.Drawing.Size(34, 16);
			this.labelOption.TabIndex = 15;
			this.labelOption.Text = ":";
			// 
			// textBoxProgram
			// 
			this.textBoxProgram.Location = new System.Drawing.Point(62, 16);
			this.textBoxProgram.Name = "textBoxProgram";
			this.textBoxProgram.Size = new System.Drawing.Size(160, 19);
			this.textBoxProgram.TabIndex = 14;
			this.textBoxProgram.Text = "";
			// 
			// labelProgram
			// 
			this.labelProgram.Location = new System.Drawing.Point(8, 16);
			this.labelProgram.Name = "labelProgram";
			this.labelProgram.Size = new System.Drawing.Size(56, 16);
			this.labelProgram.TabIndex = 13;
			this.labelProgram.Text = "vO:";
			// 
			// buttonStart
			// 
			this.buttonStart.Location = new System.Drawing.Point(48, 104);
			this.buttonStart.Name = "buttonStart";
			this.buttonStart.Size = new System.Drawing.Size(80, 24);
			this.buttonStart.TabIndex = 19;
			this.buttonStart.Text = "vZXN";
			this.buttonStart.Click += new System.EventHandler(this.buttonStart_Click);
			// 
			// buttonStop
			// 
			this.buttonStop.Enabled = false;
			this.buttonStop.Location = new System.Drawing.Point(168, 104);
			this.buttonStop.Name = "buttonStop";
			this.buttonStop.Size = new System.Drawing.Size(80, 24);
			this.buttonStop.TabIndex = 20;
			this.buttonStop.Text = "vZXI";
			this.buttonStop.Click += new System.EventHandler(this.buttonStop_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(320, 134);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.buttonStop,
																		  this.buttonStart,
																		  this.buttonFileDialog2,
																		  this.buttonFileDialog1,
																		  this.textBoxArgument,
																		  this.labelOption,
																		  this.textBoxProgram,
																		  this.labelProgram});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "Form1";
			this.Text = "ProcessSample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


	}
}
